// Proje için gerekli tüm kütüphaneler:
import org.firmata.*;
import ddf.minim.*;
import ddf.minim.analysis.*;
import processing.serial.*;
import cc.arduino.*;

Arduino arduino; 
Minim minim;
AudioInput input;
FFT fft;

// Pencere boyutları
int xmax = 600;
int ymax = 300;
 
void setup()
{
  size(xmax, ymax);
  minim = new Minim(this);
  /* Bu satırdaki Arduino.list()[x] x kısmı projenin orjinalinde 1'di ve bende çalışmadı, 0 yapınca çalıştı
  tam olarak anlayamadım, projenin sahibi arkadaşta 2 arduino mu takılıydı acaba :P */
  arduino = new Arduino(this, Arduino.list()[0], 57600);
  input = minim.getLineIn();
  fft = new FFT(input.bufferSize(), input.sampleRate());
}
 
void draw()
{
  // Bu kısım tamamen uygulama penceresi çizdirmek için
  background(0);
  fft.forward(input.mix);
  stroke(127, 255, 0, 200);
  for(int i = 10; i < fft.specSize(); i++){
    line(i, height-30, i, height - (30+fft.getFreq(i*10)));
    text("Min Freq", 10, height-10);
    text("Max Freq", fft.specSize(), height-10);
  }
  ledcontrol();
}

void ledcontrol(){
  /* draw() fonksiyonuyla birlikte bu fonksiyon çağırılıyor, bu fonksiyon aracılığıyla Arduino'ya veri yollanıyor
      5, 6, 9, 10 ve 11 nolu PWM pinleri kullandım. Program bilgisayarın ses seviyesine göre sinyal yolladığı için her frekans
      için gelen değeri 20 ile çarptım, burası tamamen opsiyonel bir kısım. Düşük denebilecek bir seviyede bile iyi bir sonuç veriyor */
  arduino.analogWrite(5, (int(fft.getFreq(200)) * 20));
  arduino.analogWrite(6, (int(fft.getFreq(400)) * 20));
  arduino.analogWrite(9, (int(fft.getFreq(600)) * 20));
  arduino.analogWrite(10, (int(fft.getFreq(800)) * 20));
  arduino.analogWrite(11, (int(fft.getFreq(1000)) * 20));
}
